function [learnedModel, Asym]= ABlearn(dataWeight,allfiltered,allsymbol,allfilter,T)
load 'nlf'; 
epsilon = .1;  % allowed correlation between selected Gabors
h = (size(allfilter{1}, 1)-1)/2;  % half size of Gabor
C = corr(allfilter, epsilon);    % generate the inhibition maps
%Totalsketch = 40;  % allowed number of selected Gabors
%Totalsketch = 30;  % allowed number of selected Gabors
Totalsketch = 50;  % allowed number of selected Gabors
sub = 2;    % subsampling rate for Gabor
Lrange = 3; % allowed shifting in location (times sub pixels)
Orange = 1; % allowed shifting in orientation
%%% Note: Lrange*sub is the pixels allowed to shift along normal
%%%       Lrange*sub should be the same in learning and testing!
SHUTUP = 1.;
% SHUTUP is to neglect the positions with low average responses
% VARIABLES FOR MEX-C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Mi = zeros(1, Totalsketch);  % orientation of selected Gabor
Mx = zeros(1, Totalsketch);  % position of selected Gabor
My = zeros(1, Totalsketch); 
Mm = zeros(1, Totalsketch);  % lambda
Mm1 = zeros(1, Totalsketch);  % logZ
sx = size(allfiltered{1,1},1);
sy = size(allfiltered{1,1},2);
sym = zeros(sx,sy);  % symbolic plot of selected Gabor
nimage = size(allfiltered,1);
norient = size(allfiltered,2);
Asym = cell(1, nimage);   % symbolic plot for each image with active Gabor
for i = 1 : nimage
    Asym{i} = zeros(sx,sy);  
end
tss = zeros(nimage, 1);  % total scores for testing images

binnum = 50; % number of bins 
% MEX-C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mex Clearn.c;   % compile C code
allfilteredback = cell(nimage,norient);
for i = 1:nimage
    for j = 1:norient
        allfilteredback{i,j} = allfiltered{i,j}+0;
    end
end
Clearn(nimage, norient, allfiltered, allfilteredback, C, h, ...
    sx, sy, Mi, Mx, My, Mm, Mm1, allsymbol(1, :), sym, Asym, Lrange,...
    Orange, sub, Totalsketch, Upperbound, tss, SHUTUP, binnum, M, lam,...
    e, lz, dataWeight);


% RESULTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% % save sketch images and results
% destFolder = '.\activeBasis_headShoulder'; % output folder
% if ~exist(destFolder,'dir')
%     mkdir(destFolder);
% end
% towrite = -(sym); 
% towrite = uint8(255 * (towrite-min(towrite(:)))/(max(towrite(:))-min(towrite(:))));
% imwrite(towrite,[destFolder '\learnedTemplate.jpg']);
% for i = 1 : nimage
%     towrite = -(Asym{i});
%     towrite = uint8(255 * (towrite-min(towrite(:)))/(max(towrite(:))-min(towrite(:))));
%     imwrite(towrite,[destFolder '\sym_' Iname(i).name],'jpg');
% end

% save([destFolder '\model.mat'],'sym','allsymbol','T','Mi','Mx','Mm','Mm1','My','C','h','Lrange','Orange','sub','scale','norient','epsilon','allfilter','allsymbol','Asym','gain','Upperbound','Totalsketch','scale','allfilter','responseVec');
learnedModel = struct('Mm',Mm,'Mm1',Mm1,'Mi',Mi,'Mx',Mx,'My',My,...
    'Lrange',Lrange,'Orange',Orange,'h',h,'sub',sub,'sx',sx,'sy',sy,...
'sym',sym,'T',T,'Upperbound',Upperbound,'epsilon',epsilon,...
'Totalsketch',Totalsketch,'tss',tss);
