function [allfiltered allfiltered_r allsymbol allfilter images] = getGaborResponse(posFolder,T,scale,norient,sx,sy)
% posFolder: image input folder

load 'nlf'; 

% TRAINING EXAMPLES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ==================================================================
%  input images from a folder
% ==================================================================

Iname = dir([posFolder '\*.jpg']);

nimage = size(Iname, 1);
I = cell(1,nimage);
Ir = cell(1,nimage);
for i = 1 : nimage
    I{i} = imresize(imread([posFolder '\' Iname(i).name]),[sx sy],'bilinear');
    if size(I{i},3)==3
        I{i} = double(rgb2gray(I{i}));
    end
    Ir{i} = fliplr(I{i});
end
images = I;

% FILTERING IMAGES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[allfilter, allsymbol] = makefilter(scale, norient);  % generate Gabor filters 

allfiltered = applyfilter(I, allfilter, T);  % filter training images
allfiltered_r = applyfilter(Ir, allfilter, T);  % filter training images

% WHITENING %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% the following three lines are the only things that need to be added
mex Ctransform.c; 
Ctransform(nimage, norient, allfiltered, sx, sy, Upperbound);
Ctransform(nimage, norient, allfiltered_r, sx, sy, Upperbound);